package eu.jonahbauer.wizard.client.libgdx.screens.eventscreens;

import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.ui.HorizontalGroup;
import com.badlogic.gdx.scenes.scene2d.ui.Label;
import com.badlogic.gdx.scenes.scene2d.ui.TextButton;
import com.badlogic.gdx.scenes.scene2d.utils.ChangeListener;
import eu.jonahbauer.wizard.client.libgdx.screens.MenuScreen;
import eu.jonahbauer.wizard.common.messages.client.InteractionMessage;
import eu.jonahbauer.wizard.common.messages.player.PredictMessage;

import java.util.Map;
import java.util.UUID;

import static com.badlogic.gdx.scenes.scene2d.actions.Actions.removeActor;
import static com.badlogic.gdx.scenes.scene2d.actions.Actions.run;

public class MakePredictionScreen extends EventScreen {

    int round;
    private UUID player;
    private final Map<UUID, Integer> predictions;
    public MakePredictionScreen(MenuScreen.Data data, int round, UUID player,Map<UUID, Integer> predictions) {
        super(data);
        this.round = round;
        this.player = player;
        this.predictions = predictions;
        showEventScreen();
    }

    @Override
    public void showEventScreen() {

        if(round == -1)
            return;

        var label = new Label("Please chose your prediction", data.skin);
        label.setFontScale(2.0f);
        group.addActor(label);

        var changeListener = new ChangeListener() {
            @Override
            public void changed(ChangeEvent event, Actor actor) {
                if(actor instanceof TextButton textButton) {
                    int chosenPrediction = Integer.parseInt(textButton.getText().toString());
                    predictions.put(player, chosenPrediction);
                    data.stage.addAction(removeActor(screen));
                    new InteractionMessage(new PredictMessage(chosenPrediction));
                }
            }
        };

        var horizontalGroup = new HorizontalGroup();
        horizontalGroup.space(30.0f);
        for(int i = 0; i <= round; i++) {
            var button = new TextButton(i + "", data.skin);
            horizontalGroup.addActor(button);
            button.addListener(changeListener);
        }
        group.addActor(horizontalGroup);
        screen.addActor(group);
        data.stage.addAction(run(() -> data.stage.addActor(screen)));
    }
}